package com.fp.persistence.pgeneral.transf;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENETRANSFERDETAIL*/
@Embeddable
public class TgeneTransferDetailKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="TRANSFERCODE", nullable=false,updatable=false)

/**
* Codigo de transferencia
*/
private Integer transfercode;

@Column(name="MODULECODE", nullable=false,updatable=false)

/**
* Codigo de modulo
*/
private String modulecode;

@Column(name="BALANCETYPE", nullable=false,updatable=false)

/**
* Código de tipo de saldo. Efectivo, Bloqueado , Pignorado, Retenciones Locales, remesas ..Etc
*/
private String balancetype;

@Column(name="BALANCEGROUP", nullable=false,updatable=false)

/**
* Codigo del grupo de balance 1 Activo, 2 Pasivo, 3 Patrimonio .. 62 contingente deudor 61 por contra deudor 
*/
private String balancegroup;

@Column(name="STATUSFROM", nullable=false,updatable=false)

/**
* Estatus de cuenta actual
*/
private String statusfrom;

@Column(name="STATUSTO", nullable=false,updatable=false)

/**
* Estatus al que se realiza la transaferencia
*/
private String statusto;

/**Contructor por defecto*/
public TgeneTransferDetailKey(){}
/**Contructor de TgeneTransferDetailKey
@param pTransfercode Codigo de transferencia
@param pModulecode Codigo de modulo
@param pBalancetype Código de tipo de saldo. Efectivo, Bloqueado , Pignorado, Retenciones Locales, remesas ..Etc
@param pBalancegroup Codigo del grupo de balance 1 Activo, 2 Pasivo, 3 Patrimonio .. 62 contingente deudor 61 por contra deudor 
@param pStatusfrom Estatus de cuenta actual
@param pStatusto Estatus al que se realiza la transaferencia
*/
public TgeneTransferDetailKey(Integer pTransfercode,String pModulecode,String pBalancetype,String pBalancegroup,String pStatusfrom,String pStatusto){
 transfercode=pTransfercode;
 modulecode=pModulecode;
 balancetype=pBalancetype;
 balancegroup=pBalancegroup;
 statusfrom=pStatusfrom;
 statusto=pStatusto;
}
/**Obtiene el valor de transfercode
@return valor de transfercode*/
public Integer getTransfercode(){
  return transfercode;
}
/**Fija el valor de transfercode
@param pTransfercode nuevo Valor de transfercode*/
public void setTransfercode(Integer pTransfercode){
  transfercode=pTransfercode;
}

/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de balancetype
@return valor de balancetype*/
public String getBalancetype(){
  return balancetype;
}
/**Fija el valor de balancetype
@param pBalancetype nuevo Valor de balancetype*/
public void setBalancetype(String pBalancetype){
  balancetype=pBalancetype;
}

/**Obtiene el valor de balancegroup
@return valor de balancegroup*/
public String getBalancegroup(){
  return balancegroup;
}
/**Fija el valor de balancegroup
@param pBalancegroup nuevo Valor de balancegroup*/
public void setBalancegroup(String pBalancegroup){
  balancegroup=pBalancegroup;
}

/**Obtiene el valor de statusfrom
@return valor de statusfrom*/
public String getStatusfrom(){
  return statusfrom;
}
/**Fija el valor de statusfrom
@param pStatusfrom nuevo Valor de statusfrom*/
public void setStatusfrom(String pStatusfrom){
  statusfrom=pStatusfrom;
}

/**Obtiene el valor de statusto
@return valor de statusto*/
public String getStatusto(){
  return statusto;
}
/**Fija el valor de statusto
@param pStatusto nuevo Valor de statusto*/
public void setStatusto(String pStatusto){
  statusto=pStatusto;
}

/**Implementación de la comparación de TgeneTransferDetailKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneTransferDetailKey))return false;
  TgeneTransferDetailKey that = (TgeneTransferDetailKey) o;
  if (this.getTransfercode() == null || that.getTransfercode() == null){
      return false;
  }
  if (! this.getTransfercode().equals(that.getTransfercode())){
    return false;
  }
  if (this.getModulecode() == null || that.getModulecode() == null){
      return false;
  }
  if (! this.getModulecode().equals(that.getModulecode())){
    return false;
  }
  if (this.getBalancetype() == null || that.getBalancetype() == null){
      return false;
  }
  if (! this.getBalancetype().equals(that.getBalancetype())){
    return false;
  }
  if (this.getBalancegroup() == null || that.getBalancegroup() == null){
      return false;
  }
  if (! this.getBalancegroup().equals(that.getBalancegroup())){
    return false;
  }
  if (this.getStatusfrom() == null || that.getStatusfrom() == null){
      return false;
  }
  if (! this.getStatusfrom().equals(that.getStatusfrom())){
    return false;
  }
  if (this.getStatusto() == null || that.getStatusto() == null){
      return false;
  }
  if (! this.getStatusto().equals(that.getStatusto())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneTransferDetailKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getTransfercode() == null ? 0 : this.getTransfercode().hashCode());
    result = result * 37 + (this.getModulecode() == null ? 0 : this.getModulecode().hashCode());
    result = result * 37 + (this.getBalancetype() == null ? 0 : this.getBalancetype().hashCode());
    result = result * 37 + (this.getBalancegroup() == null ? 0 : this.getBalancegroup().hashCode());
    result = result * 37 + (this.getStatusfrom() == null ? 0 : this.getStatusfrom().hashCode());
    result = result * 37 + (this.getStatusto() == null ? 0 : this.getStatusto().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
